<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/27/2008 *
 * ================                             Last change: 08/27/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_proxy.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Proxy settings                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Proxy-Einstellungen                              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (isset($_POST['ok'])) {
	// Test proxy settings
	if (ADMIN_TEST_PROXY_SETTINGS($_POST)) {
		// Save configuration
		ADMIN_SAVE_SETTINGS($_POST);
	} else {
		// Invalid!
		LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_PROXY_SETTINGS_INVALID);
	}
} else {
	// Prepare content
	$content = array(
		'proxy_host'     => $_CONFIG['proxy_host'],
		'proxy_port'     => $_CONFIG['proxy_port'],
		'proxy_username' => $_CONFIG['proxy_username'],
		'proxy_password' => $_CONFIG['proxy_password'],
	);

	// Load template
	LOAD_TEMPLATE("admin_config_proxy", false, $content);
}

//
?>
